;(function(root,factory,plug){
	factory.call(root,root.jQuery,plug);
})(window,function($,plug){

	//题目标题模板
	var __TITLE__ = "<label>{title}</label>";

	//题目选项模板
	var __ANSWER__ = "<div><input type='{type}' name='{inputName}' value='{inputValue}' />{answer}</div>";

	//按钮模板
	var __BUTTON__ = "<button data-button-type='prev'>上一步</button>"+
				   "<button data-button-type='next'>下一步</button>"+
				   "<button data-button-type='submit'>提交</button>"; //按钮模板（buttonSet设置为true时候生效）


	//默认设置
	var __DEFAULT__ = {
		templateTitle: __TITLE__, //标题模板
		templateAnswer: __ANSWER__, //选项模板
		buttonSet: true, //是否设置按钮
		templateButton: __BUTTON__, //按钮模板（buttonSet设置为true时候生效）
		index: 1, //从第几题开始，默认1
		hiddenClass: "hidden",
		onchange: function(){
			return;
		},
		submit: function(){
			alert("没有设置提交事件");
		},
		data: [ //默认题目
			{
				title: "title1",
				answer: ["answer1", "answer2", "answer3", "answer4"],
				type: "radio",
				inputName: "question_1",
				inputValue: ["1-answer1", "1-answer2", "1-answer3", "1-answer4"]
			},
			{
				title: "title2",
				answer: ["answer1", "answer2", "answer3", "answer4"],
				type: "checkbox",
				inputName: "question_2",
				inputValue: ["2-answer1", "2-answer2", "2-answer3", "2-answer4"]
			},
			{
				title: "title3",
				answer: ["answer1", "answer2", "answer3", "answer4"],
				type: "radio",
				inputName: "question_3",
				inputValue: ["3-answer1", "3-answer2", "3-answer3", "3-answer4"]
			}
		]
	}


	// 函数
	var __PROTOTYPE__ = {
		_init: function(){
			
		},

		_genQuestion: function(){
			var that = this;
			that.find("[data-question='true']").each(function(index){
				if (index != that.index-1) {
					$(this).addClass(that.hiddenClass);
				}

				var titleStr = that.templateTitle.replace("{title}", that.data[index].title);

				var answerStr = "";
				for (var i = 0; i < that.data[index].answer.length; i++) {
					var tempStr = that.templateAnswer.replace("{answer}", that.data[index].answer[i]);
					tempStr = tempStr.replace("{inputValue}", that.data[index].inputValue[i]);
					tempStr = tempStr.replace("{type}", that.data[index].type);
					tempStr = tempStr.replace("{inputName}", that.data[index].inputName);
					answerStr += tempStr;
				};

				that.find("[data-question='true']").eq(index).append(titleStr+answerStr);


			})
		},

		_genButton: function(){
			var that = this;
			if (that.buttonSet == false) {
				return;
			} else{
				that.find("[data-button='true']").append(that.templateButton);
			}

			if(that.index == 1){
				that.find("[data-button-type='prev']").addClass(that.hiddenClass);
				that.find("[data-button-type='submit']").addClass(that.hiddenClass);
			}else if(that.index == that.find("[data-question='true']").length){
				that.find("[data-button-type='next']").addClass(that.hiddenClass);
			}else{
				that.find("[data-button-type='submit']").addClass(that.hiddenClass);		
			}
		},

		_prev: function(that){
			var content = that.find("[data-question='true']:not(.hidden)");
			var length = that.find("[data-question='true']").length;

			if(content.index() == 1){
				content.addClass(that.hiddenClass).prev().removeClass(that.hiddenClass);
				$(this).addClass(that.hiddenClass);
			}else if(content.index() == length-1){
				$("[data-button-type='submit']").addClass(that.hiddenClass);
				$("[data-button-type='next']").removeClass(that.hiddenClass);
				content.addClass(that.hiddenClass).prev().removeClass(that.hiddenClass);
			}else{
				content.addClass(that.hiddenClass).prev().removeClass(that.hiddenClass);
			}
		},

		_next: function(that){
			var content = that.find("[data-question='true']:not(.hidden)");
			var length = that.find("[data-question='true']").length;

			if(content.index() == 0){
				$("[data-button-type='prev']").removeClass(that.hiddenClass);
				content.addClass(that.hiddenClass).next().removeClass(that.hiddenClass);
			}else if(content.index() == length-2){
				$("[data-button-type='submit']").removeClass(that.hiddenClass);
				$("[data-button-type='next']").addClass(that.hiddenClass);
				content.addClass(that.hiddenClass).next().removeClass(that.hiddenClass);
			}else{
				content.addClass(that.hiddenClass).next().removeClass(that.hiddenClass);
			}	
		},

		_bindEvent: function(){
			var that = this;
			if(that.buttonSet == true){
				// 上一题
				$("[data-button-type='prev']").on("click", function(){
					that.onchange.call(this);
					that._prev.call(this, that);
				})

				// 下一题
				$("[data-button-type='next']").on("click", function(){
					that.onchange.call(this);
					that._next.call(this, that);
				})

				// 提交
				$("[data-button-type='submit']").on("click", function(){
					that.submit.call(this);
				})
			}else{
				$("[data-question='true'] input").on("change", function(){
					var content = that.find("[data-question='true']:not(.hidden)");
					var length = that.find("[data-question='true']").length;

					if($(this).parents("[data-question='true']:not(.hidden)").next("[data-question='true']").length == 0){
						that.submit.call(this);
					}else{
						that.onchange.call(this, function(){
							content.addClass(that.hiddenClass).next().removeClass(that.hiddenClass);						
						});						
					}

				})
			}

		}
	}


	$.fn[plug] = function(options){
		$.extend(this,__PROTOTYPE__,__DEFAULT__,options);//扩展功能
		this._init();//初始化
		this._genQuestion();//生成题目
		this._genButton();//生成按钮
		this._bindEvent();//绑定事件
		// this.removeClass(this.hiddenClass);
		return this;
	}
}, "jqueryQuestion");